package yytrpc

import (
	"encoding/json"
	"errors"
	"log"
)

// 提交怡亚通订单
func CreateOrder(dbname, siteid, order_sn string, url ...string) (bool, error) {

	if dbname == "" || siteid == "" || order_sn == "" {
		return false, errors.New("参数错误")
	}

	conn, err := rpc_server_conn(url...)

	if err != nil {
		return false, err
	}

	defer conn.Close()

	data := OrderParam{}
	data.Dbname = dbname
	data.SiteId = siteid
	data.OrderSn = order_sn

	req, err := SetReqData(data)

	if err != nil {
		log.Println("CreateOrder crypter error:", err)
		return false, err
	}

	res := &Response{}

	err = conn.CreateOrder(req, res)

	if err != nil {
		log.Println("yytrpc CreateOrder error:", err)
		return false, err
	}

	res_data_de, err := GetResData(res)

	if err != nil {
		return false, err
	}

	if res_data_de == "" {
		return false, nil
	}

	var return_res bool
	err = json.Unmarshal([]byte(res_data_de), &return_res)

	if err != nil {
		return false, err
	}

	return return_res, nil
}
